var buildUrl = "Build";
var token="";
var script;
var mgr;

if (window!=window.top)
{ /* I'm in a frame! */
    try
    {
        if (!top.location.href.toLowerCase().startsWith("https://play."))
        {
            top.location.href=self.location.href;
        }
    } catch (error)
    {
        if (self.location.href.indexOf("?locale=")>-1)
        {
            top.location.href=self.location.href.substring(0,self.location.href.indexOf("?"));
        }
        else
        {
            top.location.href=self.location.href;
        }
    }
}

function SigninDirect() {
    mgr.signinRedirect({
        data: location.href,
        extraQueryParams: {
            appContext: true,
            hideexternallogin: true, //redundant
            adultexperience: false,
            childsignupexperience: "FULL"
        }
    });
}

window.addEventListener('DOMContentLoaded', (event) => {
    var container = document.querySelector("#unity-container");
    var canvas = document.querySelector("#unity-canvas");
    var loadingBar = document.querySelector("#unity-loading-bar");
    var progressBarFull = document.querySelector("#unity-progress-bar-full");
    var fullscreenButton = document.querySelector("#unity-fullscreen-button");
    var warningBanner = document.querySelector("#unity-warning");

    // Shows a temporary message banner/ribbon for a few seconds, or
    // a permanent error message on top of the canvas if type=='error'.
    // If type=='warning', a yellow highlight color is used.
    // Modify or remove this function to customize the visually presented
    // way that non-critical warnings and error messages are presented to the
    // user.

    var loaderUrl = buildUrl + "/stuntz.loader.js";  //NM: Moved to parent define
    var config = {
        dataUrl: buildUrl + "/stuntz.data.br",
        frameworkUrl: buildUrl + "/stuntz.framework.js.br",
        codeUrl: buildUrl + "/stuntz.wasm.br",
        streamingAssetsUrl: "StreamingAssets",
        companyName: "LEGO",
        productName: "Stuntz",
        productVersion: "0.1",
        showBanner: false,
    };

    // By default Unity keeps WebGL canvas render target size matched with
    // the DOM size of the canvas element (scaled by window.devicePixelRatio)
    // Set this to false if you want to decouple this synchronization from
    // happening inside the engine, and you would instead like to size up
    // the canvas DOM size and WebGL render target sizes yourself.
    // config.matchWebGLToCanvasSize = false;

    if (/iPhone|iPad|iPod|Android/i.test(navigator.userAgent)) {
        // Mobile device style: fill the whole browser client area with the game canvas:

        var meta = document.createElement('meta');
        meta.name = 'viewport';
        meta.content = 'width=device-width, height=device-height, initial-scale=1.0, user-scalable=no, shrink-to-fit=yes';
        document.getElementsByTagName('head')[0].appendChild(meta);
        container.className = "unity-mobile";

        // To lower canvas resolution on mobile devices to gain some
        // performance, uncomment the following line:
        config.devicePixelRatio = 1;

        canvas.style.width = window.innerWidth + 'px';
        canvas.style.height = window.innerHeight + 'px';

    } else {
        function resizeScreen() {
            var w = Math.min(window.innerWidth, window.innerHeight * 3 / 4 * 9 / 10);
            canvas.style.width = w + 'px';
            canvas.style.height = w * 4/3 + 'px';
        }

        resizeScreen();

        function reportWindowSize() {
            resizeScreen();
        }

        window.onresize = reportWindowSize;
    }

    loadingBar.style.display = "block";

    script = document.createElement("script");
    script.src = loaderUrl;
    script.onload = () => {
        createUnityInstance(canvas, config, (progress) => {
            progressBarFull.style.width = 100 * progress + "%";
        }).then((unityInstance) => {
            loadingBar.style.display = "none";

        }).catch((message) => {
            alert(message);
        });
    };
    if (!authenticate) {
        document.body.appendChild(script);
        return;
    }

    const game_uri = window.location.origin + window.location.pathname;
    var settings = {
        authority: 'https://identity.lego.com',
        client_id: legoClientId, //NM: Moved to parent define
        response_type: "code",
        redirect_uri: game_uri, //NM: Pretty sure we can do self.location.href here...
        silent_redirect_uri: game_uri,
        post_logout_redirect_uri: game_uri,
        silentRequestTimeout: 60000,
        automaticSilentRenew: true,
        loadUserInfo: false,
        scope: "openid profile"
    }
    Oidc.Log.logger = console;
    Oidc.Log.level = Oidc.Log.NONE;

    mgr = new Oidc.UserManager(settings);
    if (window.location.href.indexOf("?") > -1) {
        mgr.signinCallback().then(function (user) {
            self.location.href=game_uri;
        }).catch(function (error) {
            self.location.href=game_uri;
        });
    }
    else {
        mgr.signinSilent().then(function (req) {
            this.token = req.access_token;
            document.body.appendChild(this.script);

        }).catch(function (error) {
            console.log(error);
            document.body.appendChild(this.script);
        });
    }

    mgr.events.addUserLoaded(function (user) {
        this.token = user.access_token;
    });

    function _GetAccessToken() {
        return this.token;
    }
 
});
